/* 
„Erős” számok 
Egy nullától különböző sz természetes számnak az erőssége k, ha bináris alakjában pontosan k darab 1-es 
szám­jegy található. 
Például, a 23 erőssége 4 (kettes számrendszerben felírva, 4 darab 1-es számjegye van). 
Adott szám­sorozat k erősségű csoportjának nevezzük azt a részsorozatot, amely a sorozat k erősségű elemeit 
tartalmazza, az elemek eredeti sorrendjében. 
Például, az s = (7, 12, 3, 13, 24, 19), sorozat k = 2 erősségű csoportja a (12, 3, 24) részsorozat.
Határozzunk meg minden erősségi csoportot, amelyek az n (1 < n < 100) elemű x sorozat elemeiből létrehoz­hatók. 
Az elemek különböző természetes számok és kisebbek, mint 30 000. hossza. Kimenet: a csSzáma (a csoportok száma) 
és a csoportok (a létrehozott csoportok, erősségük szerint növekvően rendezve; a csoporton belül az elemek 
sorrendje tetszőleges). 
Példa: ha n = 6 és x = (12, 3, 24, 16, 15, 32), akkor csSzáma = 3, és csoportok: (16, 32), (12, 3, 24), (15).
*/

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 101;
int const maxCif = 16;

ifstream fi("erosSzamok.in");

void beOlvas(int & n, int x[]){
	
	fi >> n;
	for(int i = 1; i <= n; i++)
		fi >> x[i]; 
}

void kiIr(int n, int x[]){
	
	cout << "n = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

int erosseg(int szam){

int	ero = 0;
	do{
		szam &= szam - 1;
		ero++;
	} while(szam);
	return ero;
}

int csoportok(int n, int x[], int f[][maxDim]){
// csoportok meghatározása 
// az aktuális elemet az erősségnek megfelelő sorba helyezzük 
// a csoport számosságát a mátrix megfelelő sorában a 0 indexű elemben tároljuk  

int ero; 
int cs = 0;
	for(int i = 1; i < maxCif; i++)
		f[i][0] = 0;				// a csoportok számosságának kezdőértékei
	for(int i = 1; i <= n; i++){	// feldolgozzuk a sorozatot
		ero = erosseg(x[i]);		// az x[i] elem erőssége
		if(!f[ero][0])				// az x[i]-vel új csoport kezdődik
			cs++;					// nő a csoportok száma
		f[ero][0]++;				// nő az aktuális erőnek megfelelő sor hossza 
		f[ero][f[ero][0]] = x[i];	// elhelyezzük az elemet az erősségének megfelelő sorba
	}
	return cs;
}

void kiIrEredmeny(int cs, int f[][maxDim]){

  	cout << "csoportok szama = " << cs << endl;
  	cout << "csoportok osszetetele:" << endl;
	for(int i = 1; i < maxCif; i++){
		for(int j = 1; j <= f[i][0]; j++) 
			cout << f[i][j] << " ";
		if(f[i][0] != 0)
			cout << endl;
	}
}

int main(){
int n, cs;
int x[maxDim];
int f[maxCif][maxDim];

	beOlvas(n, x);
	kiIr(n, x);

	cs = csoportok(n, x, f);
	kiIrEredmeny(cs, f);
}

